#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef USE_KDE
#include "klicq.h"
#include <qtooltip.h>

#define xpmIcon "xpm/icon.xpm"

#include "icq-defines.h"
#include <qpixmap.h>

KLicq::KLicq(bool isDocked) :QLabel()
{

//Initilizing all the bit maps.... same once which are using on the licqgui

  char filename[1024];
  
  m_isDocked=false;

  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/offline.ppm");
  QPixmap pixmap(filename);
  setPixmap(pixmap);

  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/online.ppm");
  pmOnline = new QPixmap(filename);
  
  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/offline.ppm");
  pmOffline = new QPixmap(filename);
  
  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/away.ppm");
  pmAway = new QPixmap(filename);
  
  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/na.ppm");
  pmNa = new QPixmap(filename);
  
  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/occupied.ppm");
  pmOccupied = new QPixmap(filename);
  
  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/dnd.ppm");
  pmDnd = new QPixmap(filename);
  
  sprintf(filename, "%s%s%s", BASE_DIR, DATA_DIR, "icons.icq/message.ppm");
  pmMessage = new QPixmap(filename);

  m_isDocked = isDocked;
  
  OwnerIcon = NULL;
       
  setAlignment (AlignHCenter | AlignVCenter);
  
  QToolTip::add (this, "KLicq");



}

KLicq::~KLicq()
{
}

void KLicq::change_dock_icon(unsigned short int status)
{
  /* Danny -- Right here add butt-funk code */

  QPixmap pixmap(xpmIcon);
  setPixmap(pixmap);

  switch (status)
    {
    case 100: setPixmap((QPixmap &) *pmMessage);break;
    case ICQ_STATUS_ONLINE: setPixmap((QPixmap &) *pmOnline);break;
    case ICQ_STATUS_AWAY: setPixmap((QPixmap &) *pmAway);break;
    case ICQ_STATUS_OCCUPIED: setPixmap((QPixmap &) *pmOccupied);break;
    case ICQ_STATUS_DND: setPixmap((QPixmap &) *pmDnd);break;
    case ICQ_STATUS_NA: setPixmap((QPixmap &) *pmNa);break;
    case ICQ_STATUS_OFFLINE:setPixmap((QPixmap &) *pmOffline);break;
    default: setPixmap(pixmap);break;
   }

  setFixedSize(20,20);
  resize(20,20);

}

void KLicq::reset()
{
}

void KLicq::popresult(int index)
{
  switch (index)
    {
    case 0:emit change_status_from_dock(0);break;
    case 1:emit change_status_from_dock(1);break;
    case 2:emit change_status_from_dock(2);break;
    case 3:emit change_status_from_dock(3);break;
    case 4:emit change_status_from_dock(4);break;
    case 5:emit change_status_from_dock(5);break;
    case 6:emit change_status_from_dock(6);break;
    case 8:emit quitapp();break;
    case 10:m_dock();break;
    }
}


void KLicq::m_popupMenu(int,int)
{
// More functions have to be added here... I'll do this later. 
// but this is enough to start KDE version ;-)

        QPopupMenu *popup = new QPopupMenu(0, "popup");

        popup->insertItem("&Online");
        popup->insertItem("&Away");
        popup->insertItem("&Not Available");
        popup->insertItem("O&ccupied");
        popup->insertItem("&Do not Disturb");
        popup->insertItem("Free For &Chat");
        popup->insertItem("O&ffline");
	popup->insertSeparator();
        popup->insertItem("E&xit");
        popup->insertSeparator();
        if (m_isDocked == false)
                popup->insertItem("&Hide");
        else
                popup->insertItem("&Show");

        connect(popup, SIGNAL(activated(int)), this, SLOT(popresult(int)));
        popup->popup(QCursor::pos());
}


void KLicq::mousePressEvent(QMouseEvent *event)
{
        // check if this is a right click
        if(event->button() == RightButton)
        {
                // popup the context menu
                m_popupMenu(event->x(), event->y());
        }
	// Left click removed because of annoyance issues.
}


void KLicq::mouseDoubleClickEvent(QMouseEvent *event)
{
        // check if this is a left click
        if(event->button() == LeftButton)
        {
	  // if (!m_isDocked) emit doubleClicked();
	  emit doubleClicked();
        }
}

void KLicq::m_dock()
{
  // this is not being used... but would be used later
  // Removed by Danny Q.
  if (m_isDocked) 
    {m_isDocked=false;emit raiseicq();} 
  else
    {m_isDocked=true;emit lowericq();}  
}

#endif
